"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.mockDOMFactory = {
    createElement: function (tagName) { return new MockElement(tagName); },
    createDocumentFragment: function () {
        return new MockFragment();
    },
    createTextNode: function (nodeValue) { return new MockTextNode(nodeValue); }
};
var BaseNode = /** @class */ (function () {
    function BaseNode() {
    }
    BaseNode.prototype.remove = function () {
        this.$$parent.removeChild(this);
    };
    Object.defineProperty(BaseNode.prototype, "parentNode", {
        get: function () {
            return this.$$parent;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseNode.prototype, "innerHTML", {
        get: function () {
            return this.getInnerHTML();
        },
        enumerable: true,
        configurable: true
    });
    return BaseNode;
}());
var ParentNode = /** @class */ (function (_super) {
    __extends(ParentNode, _super);
    function ParentNode() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.childNodes = [];
        return _this;
    }
    ParentNode.prototype.appendChild = function (child) {
        var _a;
        var _this = this;
        child.$$parent = this;
        if (child instanceof MockFragment) {
            child.childNodes.forEach(function (child) {
                child.$$parent = _this;
            });
            (_a = this.childNodes).push.apply(_a, child.childNodes);
        }
        else {
            this.childNodes.push(child);
        }
    };
    ParentNode.prototype.removeChild = function (child) {
        child.$$parent = null;
        this.childNodes.splice(this.childNodes.indexOf(child), 1);
    };
    ParentNode.prototype.insertBefore = function (child, ref) {
        var _a;
        var index = this.childNodes.indexOf(ref);
        if (index === -1) {
            throw new Error("ref not found");
        }
        var children = child instanceof MockFragment ? child.childNodes : [child];
        for (var _i = 0, children_1 = children; _i < children_1.length; _i++) {
            var child_1 = children_1[_i];
            child_1.$$parent = this;
        }
        (_a = this.childNodes).splice.apply(_a, __spreadArrays([index, 0], children));
    };
    ParentNode.prototype.getInnerHTML = function () {
        var buffer = "";
        for (var _i = 0, _a = this.childNodes; _i < _a.length; _i++) {
            var child = _a[_i];
            buffer += child.toString();
        }
        return buffer;
    };
    return ParentNode;
}(BaseNode));
var MockElement = /** @class */ (function (_super) {
    __extends(MockElement, _super);
    function MockElement(tagName) {
        var _this = _super.call(this) || this;
        _this.tagName = tagName;
        _this.attributes = {};
        _this.style = {};
        return _this;
    }
    MockElement.prototype.setAttribute = function (name, value) {
        this.attributes[name] = value;
    };
    MockElement.prototype.addEventListener = function () { };
    MockElement.prototype.removeAttribute = function (name) {
        delete this.attributes[name];
    };
    MockElement.prototype.toString = function () {
        var buffer = "<" + this.tagName;
        for (var name_1 in this.attributes) {
            if (!this.attributes[name_1]) {
                continue;
            }
            buffer += " " + name_1 + "=" + JSON.stringify(this.attributes[name_1]);
        }
        buffer += ">";
        buffer += this.getInnerHTML();
        buffer += "</" + this.tagName + ">";
        return buffer;
    };
    return MockElement;
}(ParentNode));
var MockFragment = /** @class */ (function (_super) {
    __extends(MockFragment, _super);
    function MockFragment() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    MockFragment.prototype.toString = function () {
        return "";
    };
    return MockFragment;
}(ParentNode));
var MockTextNode = /** @class */ (function (_super) {
    __extends(MockTextNode, _super);
    function MockTextNode(nodeValue) {
        var _this = _super.call(this) || this;
        _this.nodeValue = nodeValue;
        return _this;
    }
    MockTextNode.prototype.getInnerHTML = function () {
        return this.toString();
    };
    MockTextNode.prototype.toString = function () {
        return this.nodeValue;
    };
    return MockTextNode;
}(BaseNode));
