"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var paperclip_utils_1 = require("paperclip-utils");
exports.patchVirtNode = function (root, mutations) {
    var _loop_1 = function (mutation) {
        var target = exports.getVirtTarget(root, mutation.nodePath);
        var action = mutation.action;
        switch (action.kind) {
            case paperclip_utils_1.ActionKind.DeleteChild: {
                var element = target;
                var children = element.children.concat();
                children.splice(action.index, 1);
                target = __assign(__assign({}, target), { children: children });
                break;
            }
            case paperclip_utils_1.ActionKind.InsertChild: {
                var element = target;
                var children = element.children.concat();
                children.splice(action.index, 0, action.child);
                target = __assign(__assign({}, target), { children: children });
                break;
            }
            case paperclip_utils_1.ActionKind.ReplaceNode: {
                target = action.replacement;
                break;
            }
            case paperclip_utils_1.ActionKind.RemoveAttribute: {
                var element = target;
                target = __assign(__assign({}, target), { attributes: element.attributes.filter(function (attr) { return attr.name !== action.name; }) });
                break;
            }
            case paperclip_utils_1.ActionKind.SetAttribute: {
                var element = target;
                var attributes = element.attributes.concat();
                var existing = attributes.find(function (attr) { return attr.name !== action.name; });
                if (existing) {
                    attributes.splice(attributes.indexOf(existing), 1, __assign(__assign({}, existing), { value: action.value }));
                }
                else {
                    attributes.push({
                        name: action.name,
                        value: action.value
                    });
                }
                target = __assign(__assign({}, target), { attributes: attributes });
                break;
            }
            case paperclip_utils_1.ActionKind.SetText: {
                target = __assign(__assign({}, target), { value: action.value });
                break;
            }
            case paperclip_utils_1.ActionKind.SourceChanged: {
                var element = target;
                // target = {...element, a: element.attributes}
            }
        }
        root = updateNode(root, mutation.nodePath, target);
    };
    for (var _i = 0, mutations_1 = mutations; _i < mutations_1.length; _i++) {
        var mutation = mutations_1[_i];
        _loop_1(mutation);
    }
    return root;
};
exports.getVirtTarget = function (mount, nodePath) {
    return nodePath.reduce(function (current, i) { return current.children[i]; }, mount);
};
var updateNode = function (ancestor, nodePath, newNode, depth) {
    if (depth === void 0) { depth = 0; }
    if (depth === nodePath.length) {
        return newNode;
    }
    return __assign(__assign({}, ancestor), { children: __spreadArrays(ancestor.children.slice(0, nodePath[depth]), [
            updateNode(ancestor.children[nodePath[depth]], nodePath, newNode, depth + 1)
        ], ancestor.children.slice(nodePath[depth] + 1)) });
};
